;This Lisp function filters object selection by color in a window
;Grant Kiba
;Ohlone College, Fremont, CA
;
;Collection function
;----------------------------------------------------------------------
(defun collect (e1)              ;Define the collection funtion
 (if (= c nil)                   ;Set if no selection set
    (setq c(ssadd e1)) ;THEN       ;Then create the set
    (setq c(ssadd e1 c)) ;ELSE     ;or add this object to the current set
 );end if
);end defun
;
;
;
;Color selection function
;------------------------------------------------------------------------------
(defun clr (/ a b c count num clrlay) ;Define function
(setq count 0)              ;Set counter to 0
(initget 6)                 ;Don't negative values
(princ "\nRed=1,Yellow=2,Green=3,Cyan=4,Blue=5,Magenta=6,White=7,Byblock=0")
(setq clrnum (getint"\nEnter color number or press \"Enter\" to select: "))   ;Get color number
(if(= clrnum nil)
  (progn
  (initget 1)
  (setq sample (entget(car(entsel "\nSelect object /w color to filter: "))))
  (if  (null (assoc 62 sample))
    (progn ;THEN
    (setq lay(cdr(assoc 8 sample)))
    (setq clrnum(cdr(assoc 62 (tblsearch "layer" lay))))
    );end progn
    (setq clrnum (cdr (assoc 62  sample))) ;ELSE
  );end if
  );end progn
);end if
(setq msg (strcat "\nFiltering color #" (itoa clrnum)))
(princ msg)
(princ "\nWindow or select objects to filter then press \"Enter\"")
(while (null a)
  (setq a (ssget))                            ;Get initial selection
  (if (null a) (princ "No objects to filter! Select again or ^C to abort."))
);end while
(setq num (sslength a))                       ;Get number of objects selected
   (while (< count num)
     (setq b (entget (ssname a count)))       ;Get entity list
      (if (/= (assoc 62 b) nil)               ;If the object has a color
      ;THEN
         (if (equal (assoc 62 b) (cons 62 clrnum))  ;If the color matches
         (collect (ssname a count))                 ;Then Collect object
         );end if
      ;ELSE                                         ;Else get object's layer
        (progn
           (setq lay(cdr(assoc 8 b)))
           (setq clrlay(cdr(assoc 62 (tblsearch "layer" lay))))
           (if (= clrnum clrlay)                   ;If the layer matches color
              (collect (ssname a count))           ;Collect the object
           );end if
        );end progn
      );end if
      (setq count (+ 1 count))           ;Check next object in set
   );end while
(if (null c)
 (progn
   (command "")
   (princ "No objects match filter color!")
   (princ)
 );end progn
(setq x c)         ;Sends the selection set to the current commad
);end if
);end defun



